<?php
namespace Claromentis\Infocapture\Repository;

$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"] ?: array()) + array("_064a039" . "fdabac69" . "a532d322" . "5d0ed0f5" . "7" => base64_decode("UHJvam" . "VjdCBu" . "b3QgZm" . "91bmQ="), "pro" . "jec" . "t_i" . "d" => base64_decode("cHJvamVjdF9" . "pZA=="), "i" . "d" => base64_decode("a" . "W" . "Q" . "="), "_49c6565477ee9f822b499" . "a53e6d2995f" => base64_decode("YXJyYXlfa2" . "V5X2V4aXN0" . "cw=="));
use Claromentis\Core\DAL;
use Claromentis\Infocapture\Exception\NotFoundException;
use Webmozart\Assert\Assert;
class ProjectRepository
{
    protected DAL\Db $database;
    
    
    
    
    
    
    protected array $projectCache = [];
    public function __construct(DAL\Db $_4504853ce5094b088c8bdc3d570a0a5d)
    {
        $this->database = $_4504853ce5094b088c8bdc3d570a0a5d;
    }
    
    
    
    
    
    
    
    public function findProject(int $projectId) : ?\HDProject
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_49c656547" . "7ee9f822b4" . "99a53e6d29" . "95f"]($projectId, $this->projectCache)) {
            $project = new \HDProject($this->database);
            if (!$project->Load($projectId)) {
                $project = null;
            }
            $this->projectCache[$projectId] = $project;
        }
        return $this->projectCache[$projectId];
    }
    
    
    
    
    
    
    
    
    public function findProjectOrFail(int $projectId) : \HDProject
    {
        $project = $this->findProject($projectId);
        if (null === $project) {
            throw new NotFoundException($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_064a039fdabac69a532d3225d0ed0" . "f57"]);
        }
        return $project;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    public function findProjectsForIssues(array $issues) : array
    {
        Assert::allIsInstanceOf($issues, \HDIssue::class);
        $_68680c984182bf7876b2bb0ab77ebe01 = [];
        foreach ($issues as $issue) {
            $projectId = (int) $issue->GetProperty($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["proje" . "ct_id"]) ?? null;
            if ($projectId) {
                $issueId = $issue->GetProperty($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["i" . "d"]);
                $_68680c984182bf7876b2bb0ab77ebe01[$issueId] = $this->findProject($projectId);
            }
        }
        return $_68680c984182bf7876b2bb0ab77ebe01;
    }
    
    
    
    
    
    
    
    public function clearCache(?int $projectId = null) : void
    {
        if (isset($projectId)) {
            unset($this->projectCache[$projectId]);
        } else {
            $this->projectCache[$projectId] = null;
        }
    }
}